aclocaldir= $(datadir)/aclocal
dist_aclocal_DATA=
+# Build targets for Windows
+if BUILD_WIN32
+include libhashkit-1.0/include.am
+include libhashkit/include.am
+include libmemcached/include.am
+include libmemcached-1.0/include.am
+else
+
include libtest/include.am
include libhashkit-1.0/include.am
include win32/include.am
include m4/include.am
+endif
TESTS += ${check_PROGRAMS}
command_not_found_handle ()
{
- echo "Command not found: '$@'"
- exit 127
+ warn "$@: command not found"
+
+ #if $DEBUG; then
+ echo ""
+ echo "Stack trace:"
+ local frame=0
+ while caller $frame; do
+ ((frame++));
+ done
+ echo ""
+ #fi
+
+ return 127
+}
+
+function error ()
+{
+ echo "$BASH_SOURCE:$BASH_LINENO: $@" >&2
}
function die ()
exit 1;
}
+function warn ()
+{
+ echo "$BASH_SOURCE:$BASH_LINENO: $@"
+ #echo "$BASH_SOURCE:$BASH_LINENO: $@" >&1
+}
+
function nassert ()
{
local param_name=\$"$1"
fi
}
-assert_file ()
+function assert_file ()
{
if [ ! -f "$1" ]; then
echo "$BASH_SOURCE:$BASH_LINENO: assert($1) does not exist: $2" >&2
fi
}
-assert_no_file ()
+function assert_no_file ()
{
if [ -f "$1" ]; then
echo "$BASH_SOURCE:$BASH_LINENO: assert($1) file exists: $2" >&2
fi
}
-assert_exec_file ()
+function assert_no_directory ()
+{
+ if [ -d "$1" ]; then
+ echo "$BASH_SOURCE:$BASH_LINENO: assert($1) directory exists: $2" >&2
+ exit 1;
+ fi
+}
+
+function assert_exec_file ()
{
if [ ! -f "$1" ]; then
echo "$BASH_SOURCE:$BASH_LINENO: assert($1) does not exist: $2" >&2
fi
}
-command_exists ()
+function command_exists ()
{
type "$1" &> /dev/null ;
}
-rebuild_host_os ()
+function rebuild_host_os ()
{
HOST_OS="${UNAME_MACHINE_ARCH}-${VENDOR}-${VENDOR_DISTRIBUTION}-${VENDOR_RELEASE}-${UNAME_KERNEL}-${UNAME_KERNEL_RELEASE}"
if [ -z "$1" ]; then
}
# Valid values are: darwin,fedora,rhel,ubuntu
-set_VENDOR_DISTRIBUTION ()
+function set_VENDOR_DISTRIBUTION ()
{
local dist=`echo "$1" | tr '[A-Z]' '[a-z]'`
case "$dist" in
esac
}
-set_VENDOR_RELEASE ()
+function set_VENDOR_RELEASE ()
{
local release=`echo "$1" | tr '[A-Z]' '[a-z]'`
case "$VENDOR_DISTRIBUTION" in
# Valid values are: apple, redhat, centos, canonical
-set_VENDOR ()
+function set_VENDOR ()
{
local vendor=`echo "$1" | tr '[A-Z]' '[a-z]'`
set_VENDOR_RELEASE $3
}
-determine_target_platform ()
+function determine_target_platform ()
{
UNAME_MACHINE_ARCH=`(uname -m) 2>/dev/null` || UNAME_MACHINE_ARCH=unknown
UNAME_KERNEL=`(uname -s) 2>/dev/null` || UNAME_SYSTEM=unknown
rebuild_host_os
}
-run_configure ()
+function run_configure ()
{
# We will run autoreconf if we are required
run_autoreconf_if_required
die "Programmer error, we entered run_configure with a stacked directory"
fi
+ if ! command_exists "$CONFIGURE"; then
+ die "$CONFIGURE does not exist"
+ fi
+
local BUILD_DIR="$1"
if [[ -n "$BUILD_DIR" ]]; then
rm -r -f $BUILD_DIR
fi
# Arguments for configure
- local CONFIGURE_ARG=
+ local BUILD_CONFIGURE_ARG=
# Set ENV DEBUG in order to enable debugging
if $DEBUG; then
- CONFIGURE_ARG='--enable-debug'
+ BUILD_CONFIGURE_ARG='--enable-debug'
fi
# Set ENV ASSERT in order to enable assert
if [[ -n "$ASSERT" ]]; then
local ASSERT_ARG=
ASSERT_ARG='--enable-assert'
- CONFIGURE_ARG="$ASSERT_ARG $CONFIGURE_ARG"
+ BUILD_CONFIGURE_ARG="$ASSERT_ARG $BUILD_CONFIGURE_ARG"
+ fi
+
+ if [[ -n "$CONFIGURE_ARG" ]]; then
+ BUILD_CONFIGURE_ARG= "$BUILD_CONFIGURE_ARG $CONFIGURE_ARG"
fi
+ ret=1;
# If we are executing on OSX use CLANG, otherwise only use it if we find it in the ENV
case $HOST_OS in
*-darwin-*)
- CC=clang CXX=clang++ $top_srcdir/configure $CONFIGURE_ARG || die "Cannot execute CC=clang CXX=clang++ configure $CONFIGURE_ARG $PREFIX_ARG"
+ CC=clang CXX=clang++ $top_srcdir/configure $BUILD_CONFIGURE_ARG || die "Cannot execute CC=clang CXX=clang++ configure $BUILD_CONFIGURE_ARG $PREFIX_ARG"
+ ret=$?
;;
rhel-5*)
- command_exists gcc44 || die "Could not locate gcc44"
- CC=gcc44 CXX=gcc44 $top_srcdir/configure $CONFIGURE_ARG $PREFIX_ARG || die "Cannot execute CC=gcc44 CXX=gcc44 configure $CONFIGURE_ARG $PREFIX_ARG"
+ command_exists 'gcc44' || die "Could not locate gcc44"
+ CC=gcc44 CXX=gcc44 $top_srcdir/configure $BUILD_CONFIGURE_ARG $PREFIX_ARG || die "Cannot execute CC=gcc44 CXX=gcc44 configure $BUILD_CONFIGURE_ARG $PREFIX_ARG"
+ ret=$?
;;
*)
- $top_srcdir/configure $CONFIGURE_ARG $PREFIX_ARG || die "Cannot execute configure $CONFIGURE_ARG $PREFIX_ARG"
+ $CONFIGURE $BUILD_CONFIGURE_ARG $PREFIX_ARG
+ ret=$?
;;
esac
+ if [ $ret -ne 0 ]; then
+ die "Could not execute $CONFIGURE $BUILD_CONFIGURE_ARG $PREFIX_ARG"
+ fi
+
if [ ! -f 'Makefile' ]; then
- die "Programmer error, configure was run but no Makefile existed afterward"
+ die "Programmer error, configure was run but no Makefile existed after $CONFIGURE was run"
fi
}
-setup_gdb_command () {
+function setup_gdb_command () {
GDB_TMPFILE=$(mktemp /tmp/gdb.XXXXXXXXXX)
echo 'set logging overwrite on' > $GDB_TMPFILE
echo 'set logging on' >> $GDB_TMPFILE
GDB_COMMAND="gdb -f -batch -x $GDB_TMPFILE"
}
-setup_valgrind_command () {
+function setup_valgrind_command () {
VALGRIND_PROGRAM=`type -p valgrind`
if [[ -n "$VALGRIND_PROGRAM" ]]; then
VALGRIND_COMMAND="$VALGRIND_PROGRAM --error-exitcode=1 --leak-check=yes --show-reachable=yes --track-fds=yes --malloc-fill=A5 --free-fill=DE"
fi
}
-push_PREFIX_ARG ()
+function save_BUILD ()
+{
+ if [[ -n "$OLD_CONFIGURE" ]]; then
+ die "OLD_CONFIGURE($OLD_CONFIGURE) was set on push, programmer error!"
+ fi
+
+ if [[ -n "$OLD_CONFIGURE_ARG" ]]; then
+ die "OLD_CONFIGURE_ARG($OLD_CONFIGURE_ARG) was set on push, programmer error!"
+ fi
+
+ if [[ -n "$OLD_MAKE" ]]; then
+ die "OLD_MAKE($OLD_MAKE) was set on push, programmer error!"
+ fi
+
+ if [[ -n "$OLD_TESTS_ENVIRONMENT" ]]; then
+ die "OLD_TESTS_ENVIRONMENT($OLD_TESTS_ENVIRONMENT) was set on push, programmer error!"
+ fi
+
+ if [[ -n "$CONFIGURE" ]]; then
+ OLD_CONFIGURE=$CONFIGURE
+ fi
+
+ if [[ -n "$CONFIGURE_ARG" ]]; then
+ OLD_CONFIGURE_ARG=$CONFIGURE_ARG
+ fi
+
+ if [[ -n "$MAKE" ]]; then
+ OLD_MAKE=$MAKE
+ fi
+
+ if [[ -n "$TESTS_ENVIRONMENT" ]]; then
+ OLD_TESTS_ENVIRONMENT=$TESTS_ENVIRONMENT
+ fi
+}
+
+function restore_BUILD ()
{
+ if [[ -n "$OLD_CONFIGURE" ]]; then
+ CONFIGURE=$OLD_CONFIGURE
+ fi
+
+ if [[ -n "$OLD_CONFIGURE_ARG" ]]; then
+ CONFIGURE_ARG=$OLD_CONFIGURE_ARG
+ fi
+
+ if [[ -n "$OLD_MAKE" ]]; then
+ MAKE=$OLD_MAKE
+ fi
+
+ if [[ -n "$OLD_TESTS_ENVIRONMENT" ]]; then
+ TESTS_ENVIRONMENT=$OLD_TESTS_ENVIRONMENT
+ fi
+
+ OLD_CONFIGURE=
+ OLD_CONFIGURE_ARG=
+ OLD_MAKE=
+ OLD_TESTS_ENVIRONMENT=
+ echo "reset happened"
+}
+
+function push_PREFIX_ARG ()
+{
+ if [[ -n "$OLD_PREFIX_ARG" ]]; then
+ die "OLD_PREFIX_ARG was set on push, programmer error!"
+ fi
+
if [[ -n "$PREFIX_ARG" ]]; then
OLD_PREFIX_ARG=$PREFIX_ARG
PREFIX_ARG=
fi
}
-pop_PREFIX_ARG ()
+function pop_PREFIX_ARG ()
{
if [[ -n "$OLD_PREFIX_ARG" ]]; then
- PREFIX_ARG=$OLD_TESTS_ENVIRONMENT
+ PREFIX_ARG=$OLD_PREFIX_ARG
OLD_PREFIX_ARG=
else
PREFIX_ARG=
fi
}
-push_TESTS_ENVIRONMENT ()
+function push_TESTS_ENVIRONMENT ()
{
if [[ -n "$OLD_TESTS_ENVIRONMENT" ]]; then
die "OLD_TESTS_ENVIRONMENT was set on push, programmer error!"
fi
}
-pop_TESTS_ENVIRONMENT ()
+function pop_TESTS_ENVIRONMENT ()
{
TESTS_ENVIRONMENT=
if [[ -n "$OLD_TESTS_ENVIRONMENT" ]]; then
snapshot_check
}
-function make_for_mingw32 ()
+function check_mingw ()
{
- # Make sure it is clean
- if [ -f Makefile -o -f configure ]; then
- make_maintainer_clean
+ command_exists 'mingw64-configure'
+ ret=$?
+ if [ "$ret" -ne 0 ]; then
+ return 1
fi
- assert_no_file 'Makefile'
- if command_exists mingw32-configure; then
- run_autoreconf
+ command_exists 'mingw64-make'
+ ret=$?
+ if [ "$ret" -ne 0 ]; then
+ return 1
+ fi
+
+ return 0
+}
- mingw32-configure || die 'mingw32-configure failed'
+function make_skeleton_mingw ()
+{
+ run_configure
+ ret=$?
+
+ if [ $ret -eq 0 ]; then
assert_file 'Makefile'
- if command_exists mingw32-make; then
- mingw32-make || die 'mingw32-make failed'
+ make_target 'all' 'warn'
+ ret=$?
+ if [ $ret -ne 0 ]; then
+ warn "$MAKE failed"
+ else
+ if [[ -n "$DISPLAY" ]]; then
+ if command_exists 'wine'; then
+ TESTS_ENVIRONMENT='wine'
+ fi
+ elif command_exists 'wineconsole'; then
+ TESTS_ENVIRONMENT='wineconsole --backend=curses'
+ fi
+
+ if [[ -n "$TESTS_ENVIRONMENT" ]]; then
+ make_target 'check' 'warn' || warn "$MAKE check failed"
+ ret=$?
+ fi
+ fi
+
+ if $jenkins_build_environment; then
+ make_target 'clean' 'warn'
fi
fi
+
+ return $ret
+}
+
+function make_for_mingw ()
+{
+ check_mingw
+ if ! check_mingw; then
+ die 'mingw64 tools were not found'
+ fi
+
+ # Make sure it is clean
+ if [ -f Makefile -o -f configure ]; then
+ make_maintainer_clean
+ fi
+
+ run_autoreconf
+
+ save_BUILD
+
+ CONFIGURE='mingw64-configure'
+ MAKE='mingw64-make'
+ CONFIGURE_ARGS='--enable-static'
+
+ make_skeleton_mingw
+ ret=$?
+
+ restore_BUILD
+
+ return $ret
}
# If we are locally testing, we should make sure the environment is setup correctly
make_valgrind
make_gdb
make_rpm
- make_for_mingw32
+
+ if [ check_mingw -eq 0 ]; then
+ make_for_mingw
+ fi
+
make_distcheck
make_install_system
}
eval "./bootstrap.sh maintainer-clean" || die "failed 'maintainer-clean'"
}
-function make_gdb ()
+function make_install_html ()
{
run_configure_if_required
+ assert_file 'configure'
- if command_exists gdb; then
+ make_target 'install-html'
+}
+
+function make_gdb ()
+{
+ if command_exists 'gdb'; then
+ run_configure_if_required
push_TESTS_ENVIRONMENT
TESTS_ENVIRONMENT="$GDB_COMMAND"
fi
- make_target check
+ make_target 'check'
if [ -f 'gdb.txt' ]; then
rm 'gdb.txt'
if [ -f '.gdb_history' ]; then
rm '.gdb_history'
fi
+
+ if $jenkins_build_environment; then
+ make_target 'clean'
+ fi
else
echo 'gdb was not present'
return 1
die "MAKE was not set"
fi
- if [ -n "$2" ]; then
- run $MAKE $1 || return 1
- else
- run $MAKE $1 || die "Cannot execute $MAKE $1"
+ # $2 represents error or warn
+ run $MAKE $1
+ ret=$?
+
+ if [ $ret -ne 0 ]; then
+ if [ -n "$2" ]; then
+ warn "Cannot execute $MAKE $1: $ret"
+ else
+ die "Cannot execute $MAKE $1: $ret"
+ fi
fi
+
+ return $ret
}
function make_distcheck ()
function make_rpm ()
{
- if [ -f 'rpm.am' -o -d 'rpm' ]; then
- run_configure_if_required
- make_target 'rpm'
+ if command_exists 'rpmbuild'; then
+ if [ -f 'rpm.am' -o -d 'rpm' ]; then
+ run_configure_if_required
+ make_target 'rpm'
+
+ if $jenkins_build_environment; then
+ make_target 'clean'
+ fi
+
+ fi
fi
}
{
run_configure_if_required
make_target 'maintainer-clean' 'no_error'
+
+ # Lets make sure we really cleaned up the environment
+ assert_no_file 'Makefile'
+ assert_no_file 'configure'
+ assert_no_directory 'autom4te.cache'
}
function make_check ()
echo "\`$@' $ARGS"
fi
+ if [ -z "$1" ]; then
+ return 127;
+ fi
+
eval $@ $ARGS
}
-parse_command_line_options ()
+function parse_command_line_options ()
{
local SHORTOPTS=':apcmt:dvh'
fi
}
-determine_vcs ()
+function determine_vcs ()
{
if [[ -d '.git' ]]; then
VCS_CHECKOUT=git
{
# Set ENV MAKE in order to override "make"
if [[ -z "$MAKE" ]]; then
- if command_exists gmake; then
+ if command_exists 'gmake'; then
MAKE=`type -p gmake`
else
- if command_exists make; then
+ if command_exists 'make'; then
MAKE=`type -p make`
fi
fi
run $AUTORECONF '--help' &> /dev/null || die "Failed to run AUTORECONF:$AUTORECONF"
}
-print_setup ()
+function print_setup ()
{
saved_debug_status=$DEBUG
if $DEBUG; then
fi
}
-make_clean_option ()
+function make_clean_option ()
{
run_configure_if_required
fi
}
-make_for_autoreconf ()
+function make_for_autoreconf ()
{
if [ -f 'Makefile' ]; then
make_maintainer_clean
assert_no_file 'Makefile'
}
-check_make_target()
+function check_make_target()
{
case $1 in
'self')
'gdb')
make_gdb
;;
+ 'install-html')
+ make_install_html
+ ;;
'clean_op')
make_clean_option
;;
make_default
;;
'mingw')
- make_for_mingw32
+ check_mingw
+ if ! check_mingw; then
+ die "mingw was not found"
+ fi
+
+ make_for_mingw
+ check_ret=$?
+
+ if ! make_for_mingw; then
+ die "Failed to build mingw: $?"
+ fi
;;
'snapshot')
make_for_snapshot
done
}
-main ()
+function main ()
{
# Variables we export
declare -x VCS_CHECKOUT=
# Variables we control globally
local MAKE_TARGET=
+ local CONFIGURE=
# Options for getopt
local AUTORECONF_OPTION=false
local TARGET_OPTION_ARG=
local VERBOSE_OPTION=false
+ local OLD_CONFIGURE=
+ local OLD_CONFIGURE_ARG=
+ local OLD_MAKE=
+ local OLD_TESTS_ENVIRONMENT=
+
# If we call autoreconf on the platform or not
local AUTORECONF_REBUILD_HOST=false
local AUTORECONF_REBUILD=false
local -r top_srcdir=`pwd`
+ # Default configure
+ if [ -z "$CONFIGURE" ]; then
+ CONFIGURE="$top_srcdir/configure"
+ fi
+
+
# Variables for determine_target_platform () and rebuild_host_os ()
# UNAME_MACHINE_ARCH= uname -m
# VENDOR= apple, redhat, centos, canonical
fi
}
-enable_debug ()
+function enable_debug ()
{
if ! $DEBUG; then
local caller_loc=`caller`
EOF
}
-disable_debug ()
+function disable_debug ()
{
set +x
DEBUG=true
# include <winsock2.h>
# include <ws2tcpip.h>
-typedef short in_port_t;
+#ifndef HAVE_IN_PORT_T
+typedef int in_port_t;
+# define HAVE_IN_PORT_T 1
+#endif
+
typedef SOCKET memcached_socket_t;
#else
# include <dlfcn.h>
#endif
+#if defined(WIN32) || defined(__MINGW32__)
+# include "libmemcached/windows.hpp"
+#endif
+
#include <libmemcached-1.0/memcached.h>
#include <libmemcached/watchpoint.h>
#include <libmemcached/is.h>
#endif
+#if defined(_WIN32)
+#else
#if defined(SO_NOSIGPIPE)
if (SO_NOSIGPIPE)
{
#endif
}
}
-#endif
+#endif // SO_NOSIGPIPE
+#endif // _WIN32
if (server->root->flags.no_block)
{
return MEMCACHED_SUCCESS;
#else
+ (void)instance;
+ (void)vector;
+ (void)count;
return MEMCACHED_FAILURE;
#endif
}
if (str and str->size and local_errno)
{
- error->size= (int)snprintf(error->message, MAX_ERROR_LENGTH, "(%lu) %s(%s), %.*s -> %s",
- long(error->root),
+ error->size= (int)snprintf(error->message, MAX_ERROR_LENGTH, "(%p) %s(%s), %.*s -> %s",
+ error->root,
memcached_strerror(&memc, rc),
errmsg_ptr,
memcached_string_printf(*str), at);
}
else if (local_errno)
{
- error->size= (int)snprintf(error->message, MAX_ERROR_LENGTH, "(%lu) %s(%s) -> %s",
- long(error->root),
+ error->size= (int)snprintf(error->message, MAX_ERROR_LENGTH, "(%p) %s(%s) -> %s",
+ error->root,
memcached_strerror(&memc, rc),
errmsg_ptr,
at);
}
else if (rc == MEMCACHED_PARSE_ERROR and str and str->size)
{
- error->size= (int)snprintf(error->message, MAX_ERROR_LENGTH, "(%lu) %.*s -> %s",
- long(error->root),
+ error->size= (int)snprintf(error->message, MAX_ERROR_LENGTH, "(%p) %.*s -> %s",
+ error->root,
int(str->size), str->c_str, at);
}
else if (str and str->size)
{
- error->size= (int)snprintf(error->message, MAX_ERROR_LENGTH, "(%lu) %s, %.*s -> %s",
- long(error->root),
+ error->size= (int)snprintf(error->message, MAX_ERROR_LENGTH, "(%p) %s, %.*s -> %s",
+ error->root,
memcached_strerror(&memc, rc),
int(str->size), str->c_str, at);
}
else
{
- error->size= (int)snprintf(error->message, MAX_ERROR_LENGTH, "(%lu) %s -> %s",
- long(error->root),
+ error->size= (int)snprintf(error->message, MAX_ERROR_LENGTH, "(%p) %s -> %s",
+ error->root,
memcached_strerror(&memc, rc), at);
}
libmemcached_libmemcached_la_CFLAGS= -DBUILDING_LIBMEMCACHED
libmemcached_libmemcached_la_CXXFLAGS= -DBUILDING_LIBMEMCACHED
+if BUILD_WIN32
+libmemcached_libmemcached_la_CFLAGS+= -DBUILDING_HASHKIT
+libmemcached_libmemcached_la_CXXFLAGS+= -DBUILDING_HASHKIT
+libmemcached_libmemcached_la_LIBADD+= -lmingw64
+libmemcached_libmemcached_la_LIBADD+= -lws2_64
+endif
+
libmemcached_libmemcached_la_SOURCES+= libmemcached/instance.cc
libmemcached_libmemcached_la_SOURCES+= ${libhashkit_libhashkit_la_SOURCES}
libmemcached_libmemcached_la_SOURCES+= libmemcached/allocators.cc
#endif
#ifdef __cplusplus
-static inline void memcached_close_socket(int& socket_fd)
+static inline void memcached_close_socket(memcached_socket_t& socket_fd)
{
closesocket(socket_fd);
socket_fd= INVALID_SOCKET;
#pragma once
-#include <spawn.h>
+#ifdef _WIN32
+typedef int posix_spawn_file_actions_t;
+#else
+# include <spawn.h>
+#endif
+
+#include <pthread.h>
// http://www.gnu.org/software/automake/manual/automake.html#Using-the-TAP-test-protocol
#ifndef EXIT_SKIP
// The following are just for unittesting the exception class
static bool is_disabled();
static void disable();
- static void enable();
+
static uint32_t disabled_counter();
static void increment_disabled_counter();
Server::~Server()
{
- kill();
+ murder();
}
bool Server::check()
while (--limit and
is_pid_valid(_app.pid()))
{
- if (kill())
+ if (murder())
{
Log << "Killed existing server," << *this;
dream(0, 50000);
return true;
}
-bool Server::kill()
+bool Server::murder()
{
if (check_pid(_app.pid())) // If we kill it, reset
{
#include <cassert>
#include <cstdio>
#include <cstring>
+
#include <netdb.h>
#include <netinet/in.h>
+
#include <string>
#include <unistd.h>
#include <vector>
std::string log_and_pid();
- bool kill();
+ bool murder();
bool start();
bool command(libtest::Application& app);
{
Server* tmp= servers[host_to_shutdown];
- if (tmp and tmp->kill() == false)
+ if (tmp and tmp->murder() == false)
{ }
else
{
bool success= true;
for (std::vector<Server *>::iterator iter= servers.begin(); iter != servers.end(); ++iter)
{
- if ((*iter)->has_pid() and (*iter)->kill() == false)
+ if ((*iter)->has_pid() and (*iter)->murder() == false)
{
Error << "Unable to kill:" << *(*iter);
success= false;
#include <cassert>
#include <cstdio>
#include <cstring>
+
#include <netdb.h>
#include <netinet/in.h>
+
#include <string>
#include <unistd.h>
#include <vector>
mach_port_deallocate(mach_task_self(), _clock_serv);
ts.tv_sec= _mach_timespec.tv_sec;
ts.tv_nsec= _mach_timespec.tv_nsec;
+#elif defined(_WIN32)
+ ts.tv_sec= time(NULL);
+ ts.tv_nsec= 0;
#else
clock_gettime(CLOCK_REALTIME, &ts);
#endif
#include <unistd.h>
#include <string>
-#include <signal.h>
+#include <csignal>
+#include <sys/types.h>
#include <libtest/dream.h>
namespace libtest {
# and this notice are preserved. This file is offered as-is, without any
# warranty.
-#serial 9
+#serial 10
AC_DEFUN([AX_CXX_GCC_ABI_DEMANGLE],
[AC_PREREQ([2.63])dnl
template<typename TYPE>
class A {};]],
[[A<int> instance;
+#if defined(_WIN32)
+ return EXIT_FAILURE;
+#endif
int status = 0;
char* c_name = abi::__cxa_demangle(typeid(instance).name(), 0, 0, &status);
[ax_cv_cxx_gcc_abi_demangle=no],
[ax_cv_cxx_gcc_abi_demangle=no])
AC_LANG_POP])
+ AC_MSG_CHECKING([checking for cxx_gcc_abi_demangle])
+ AC_MSG_RESULT(["$ax_cv_cxx_gcc_abi_demangle"])
AS_IF([test "x$ax_cv_cxx_gcc_abi_demangle" = xyes],
[AC_DEFINE([HAVE_GCC_ABI_DEMANGLE],[1],[define if the compiler supports GCC C++ ABI name demangling])])
])
])
])
+# Note: Should this be LIBS or LDFLAGS?
AC_DEFUN([_APPEND_LINK_FLAGS_ERROR],
[AC_REQUIRE([AX_APPEND_LINK_FLAGS])
- AX_APPEND_LINK_FLAGS([$1],[LIB],[-Werror])
+ AX_APPEND_LINK_FLAGS([$1],[LDFLAGS],[-Werror])
])
AC_DEFUN([_APPEND_COMPILE_FLAGS_ERROR],
AC_DEFUN([_HARDEN_LINKER_FLAGS],
[_APPEND_LINK_FLAGS_ERROR([-z relro -z now])
- _APPEND_LINK_FLAGS_ERROR([-pie])
+ #_APPEND_LINK_FLAGS_ERROR([-pie])
AS_IF([test "x$ac_cv_warnings_as_errors" = xyes],
[AX_APPEND_LINK_FLAGS([-Werror])])
])
[_APPEND_COMPILE_FLAGS_ERROR([-g])
_APPEND_COMPILE_FLAGS_ERROR([-O2])])
- _APPEND_COMPILE_FLAGS_ERROR([-Wno-pragmas])
+ AS_IF([test "x$ac_cv_vcs_checkout" = xyes],
+ [_APPEND_COMPILE_FLAGS_ERROR([-fstack-check])],
+ [_APPEND_COMPILE_FLAGS_ERROR([-Wno-pragmas])])
+
_APPEND_COMPILE_FLAGS_ERROR([-Wall])
_APPEND_COMPILE_FLAGS_ERROR([-Wextra])
_APPEND_COMPILE_FLAGS_ERROR([-Wunknown-pragmas])
AS_IF([test "x$ax_enable_debug" = xno],
[AS_IF([test "x$ac_cv_vcs_checkout" = xyes],
- [_APPEND_COMPILE_FLAGS_ERROR([-fstack-check])
- AS_IF([test "x$ac_c_gcc_recent" = xyes],
- [_APPEND_COMPILE_FLAGS_ERROR([-D_FORTIFY_SOURCE=2])
-# _APPEND_COMPILE_FLAGS_ERROR([-Wstack-protector])
- _APPEND_COMPILE_FLAGS_ERROR([-fstack-protector])
-# _APPEND_COMPILE_FLAGS_ERROR([-fstack-protector-all])
- ])])])
-
- AS_IF([test "x$ac_cv_vcs_checkout" = xyes],
- [_APPEND_COMPILE_FLAGS_ERROR([-fstack-check])],
- [_APPEND_COMPILE_FLAGS_ERROR([-Wno-pragmas])])
+ [AS_IF([test "x${target_os}" != "xmingw"],
+ [AS_IF([test "x$ac_c_gcc_recent" = xyes],
+ [_APPEND_COMPILE_FLAGS_ERROR([-D_FORTIFY_SOURCE=2])
+ #_APPEND_COMPILE_FLAGS_ERROR([-Wstack-protector])
+ #_APPEND_COMPILE_FLAGS_ERROR([-fstack-protector])
+ _APPEND_COMPILE_FLAGS_ERROR([-fstack-protector-all])
+ ])])])])
AS_IF([test "x$ac_cv_warnings_as_errors" = xyes],
[AX_APPEND_FLAG([-Werror])])
AS_IF([test "x$ax_enable_debug" = xno],
[AS_IF([test "x$ac_cv_vcs_checkout" = xyes],
- [_APPEND_COMPILE_FLAGS_ERROR([-fstack-check])
- AS_IF([test "x$ac_c_gcc_recent" = xyes],
- [_APPEND_COMPILE_FLAGS_ERROR([-D_FORTIFY_SOURCE=2])
-# _APPEND_COMPILE_FLAGS_ERROR([-Wstack-protector])
- _APPEND_COMPILE_FLAGS_ERROR([-fstack-protector])
-# _APPEND_COMPILE_FLAGS_ERROR([-fstack-protector-all])
- ])])])
+ [AS_IF([test "x${target_os}" != "xmingw"],
+ [AS_IF([test "x$ac_c_gcc_recent" = xyes],
+ [_APPEND_COMPILE_FLAGS_ERROR([-D_FORTIFY_SOURCE=2])
+ #_APPEND_COMPILE_FLAGS_ERROR([-Wstack-protector])
+ #_APPEND_COMPILE_FLAGS_ERROR([-fstack-protector])
+ _APPEND_COMPILE_FLAGS_ERROR([-fstack-protector-all])
+ ])])])])
AS_IF([test "x$ac_cv_warnings_as_errors" = xyes],
[AX_APPEND_FLAG([-Werror])])
# ===========================================================================
-# http://www.gnu.org/software/autoconf-archive/ax_count_cpus.html
+# http://
# ===========================================================================
#
# SYNOPSIS
# and this notice are preserved. This file is offered as-is, without any
# warranty.
-#serial 1
+#serial 3
+#
AC_DEFUN([AX_PLATFORM],
[AC_REQUIRE([AC_CANONICAL_HOST])
AC_REQUIRE([AC_CANONICAL_TARGET])
AC_DEFINE_UNQUOTED([TARGET_CPU],["$target_cpu"], [CPU of Target System])
AS_CASE([$target_os],
- [*mingw32*],
- [AC_DEFINE([TARGET_OS_WINDOWS], [1], [Whether we are building for Windows])
- AC_DEFINE([WINVER], [WindowsXP], [Version of Windows])
- AC_DEFINE([_WIN32_WINNT], [0x0501], [Magical number to make things work])
+ [*mingw*],
+ [TARGET_WINDOWS="true"
+ AC_DEFINE([TARGET_OS_WINDOWS], [1], [Whether we are building for Windows])
AC_DEFINE([EAI_SYSTEM], [11], [Another magical number])
AH_BOTTOM([
#ifndef HAVE_SYS_SOCKET_H
[*freebsd*],[AC_DEFINE([TARGET_OS_FREEBSD],[1],[Whether we are building for FreeBSD])
AC_DEFINE([__APPLE_CC__],[1],[Workaround for bug in FreeBSD headers])],
[*solaris*],[AC_DEFINE([TARGET_OS_SOLARIS],[1],[Whether we are building for Solaris])],
- [*darwin*],[AC_DEFINE([TARGET_OS_OSX],[1],[Whether we build for OSX])],
- [*linux*],[AC_DEFINE([TARGET_OS_LINUX],[1],[Whether we build for Linux])])
+ [*darwin*],
+ [TARGET_OSX="true"
+ AC_DEFINE([TARGET_OS_OSX],[1],[Whether we build for OSX])],
+ [*linux*],
+ [TARGET_LINUX="true"
+ AC_DEFINE([TARGET_OS_LINUX],[1],[Whether we build for Linux])])
AM_CONDITIONAL([BUILD_WIN32],[test "x${TARGET_WINDOWS}" = "xtrue"])
AM_CONDITIONAL([TARGET_OSX],[test "x${TARGET_OSX}" = "xtrue"])
])
])
- AM_CONDITIONAL(HAVE_DPKG_GENSYMBOLS,[test "x${DPKG_GENSYMBOLS}" != "x:"])
- AM_CONDITIONAL(HAVE_SPHINX,[test "x${SPHINXBUILD}" != "x:"])
- AM_CONDITIONAL(HAVE_RECENT_SPHINX,[test "x${ac_cv_recent_sphinx}" = "xyes"])
+ AM_CONDITIONAL([HAVE_DPKG_GENSYMBOLS],[test "x${DPKG_GENSYMBOLS}" != "x:"])
+ AM_CONDITIONAL([HAVE_SPHINX],[test "x${SPHINXBUILD}" != "x:"])
+ AM_CONDITIONAL([HAVE_RECENT_SPHINX],[test "x${ac_cv_recent_sphinx}" = "xyes"])
])
-dnl Copyright (C) 2012 Data Differential LLC
-dnl Copyright (C) 2011 Trond Norbye
-dnl This file is free software; Trond Norbye
-dnl gives unlimited permission to copy and/or distribute it,
-dnl with or without modifications, as long as this notice is preserved.
-dnl ---------------------------------------------------------------------------
-dnl Macro: SOCKET_SEND_FLAGS
-dnl ---------------------------------------------------------------------------
-
-AC_DEFUN([SOCKET_SEND_FLAGS],[
- AC_CACHE_CHECK([for MSG_NOSIGNAL], [ac_cv_msg_nosignal], [
- AC_LANG_PUSH([C])
- AX_SAVE_FLAGS
- CFLAGS="$CFLAGS -I${srcdir}"
-
- AC_COMPILE_IFELSE([AC_LANG_PROGRAM([#include <netdb.h>], [ int flags= MSG_NOSIGNAL ])], [ac_cv_msg_nosignal="yes"])
- AC_LANG_POP
- AX_RESTORE_FLAGS
+# Copyright (C) 2012-2013 Data Differential LLC
+# Copyright (C) 2011 Trond Norbye
+# This file is free software; Trond Norbye and Data Differential
+# gives unlimited permission to copy and/or distribute it,
+# with or without modifications, as long as this notice is preserved.
+# ---------------------------------------------------------------------------
+# Macro: SOCKET_SEND_FLAGS
+# ---------------------------------------------------------------------------
+#
+
+#serial 2
+
+AC_DEFUN([SOCKET_SEND_FLAGS],
+ [AC_CACHE_CHECK([for MSG_NOSIGNAL],[ac_cv_msg_nosignal],
+ [AC_LANG_PUSH([C])
+ AX_SAVE_FLAGS
+ CFLAGS="$CFLAGS -I${srcdir}"
+
+ AC_COMPILE_IFELSE([AC_LANG_PROGRAM([#include <netdb.h>], [int flags= MSG_NOSIGNAL])], [ac_cv_msg_nosignal="yes"])
+ AC_LANG_POP
+ AX_RESTORE_FLAGS])
+
+ AC_CACHE_CHECK([for MSG_DONTWAIT],[ac_cv_msg_dontwait],
+ [AC_LANG_PUSH([C])
+ AX_SAVE_FLAGS
+ CFLAGS="$CFLAGS -I${srcdir}"
+
+ AC_COMPILE_IFELSE([AC_LANG_PROGRAM([#include <netdb.h>],[int flags= MSG_DONTWAIT])],[ac_cv_msg_dontwait="yes"])
+ AC_LANG_POP
+ AX_RESTORE_FLAGS])
+
+ AC_CACHE_CHECK([for MSG_MORE],[ac_cv_msg_more],
+ [AC_LANG_PUSH([C])
+ AX_SAVE_FLAGS
+ CFLAGS="$CFLAGS -I${srcdir}"
+ AC_COMPILE_IFELSE([AC_LANG_PROGRAM([#include <netdb.h>], [int flags= MSG_MORE])], [ac_cv_msg_more="yes"])
+ AC_LANG_POP
+ AX_RESTORE_FLAGS])
+
+ AS_IF([test "x$ac_cv_msg_nosignal" = "xyes"],[AC_DEFINE([HAVE_MSG_NOSIGNAL],[1],[Define to 1 if you have a MSG_NOSIGNAL])])
+ AS_IF([test "x$ac_cv_msg_dontwait" = "xyes"],[AC_DEFINE([HAVE_MSG_DONTWAIT],[1],[Define to 1 if you have a MSG_DONTWAIT])])
+ AS_IF([test "x$ac_cv_msg_more" = "xyes"],[AC_DEFINE([HAVE_MSG_MORE],[1],[Define to 1 if you have a MSG_MORE])])
])
- AC_CACHE_CHECK([for MSG_DONTWAIT], [ac_cv_msg_dontwait], [
- AC_LANG_PUSH([C])
- AX_SAVE_FLAGS
- CFLAGS="$CFLAGS -I${srcdir}"
-
- AC_COMPILE_IFELSE([AC_LANG_PROGRAM([#include <netdb.h>], [ int flags= MSG_DONTWAIT ])], [ac_cv_msg_dontwait="yes"])
- AC_LANG_POP
- AX_RESTORE_FLAGS
- ])
-
- AC_CACHE_CHECK([for MSG_MORE], [ac_cv_msg_more], [
- AC_LANG_PUSH([C])
- AX_SAVE_FLAGS
- CFLAGS="$CFLAGS -I${srcdir}"
-
- AC_COMPILE_IFELSE([AC_LANG_PROGRAM([#include <netdb.h>], [ int flags= MSG_MORE ])], [ac_cv_msg_more="yes"])
- AC_LANG_POP
- AX_RESTORE_FLAGS
- ])
-
- AS_IF([test "x$ac_cv_msg_nosignal" = "xyes"],[ AC_DEFINE(HAVE_MSG_NOSIGNAL, 1, [Define to 1 if you have a MSG_NOSIGNAL])])
- AS_IF([test "x$ac_cv_msg_dontwait" = "xyes"],[ AC_DEFINE(HAVE_MSG_DONTWAIT, 1, [Define to 1 if you have a MSG_DONTWAIT])])
- AS_IF([test "x$ac_cv_msg_more" = "xyes"],[ AC_DEFINE(HAVE_MSG_MORE, 1, [Define to 1 if you have a MSG_MORE])])
-])
-
-dnl ---------------------------------------------------------------------------
-dnl End Macro: SOCKET_SEND_FLAGS
-dnl ---------------------------------------------------------------------------
+# ---------------------------------------------------------------------------
+# End Macro: SOCKET_SEND_FLAGS
+# ---------------------------------------------------------------------------